/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */
import{lll}from"@typo3/core/lit-helper.js";import DocumentService from"@typo3/core/document-service.js";import Notification from"@typo3/backend/notification.js";import InfoWindow from"@typo3/backend/info-window.js";import{BroadcastMessage}from"@typo3/backend/broadcast-message.js";import broadcastService from"@typo3/backend/broadcast-service.js";import NProgress from"nprogress";import Icons from"@typo3/backend/icons.js";import AjaxRequest from"@typo3/core/ajax/ajax-request.js";import RegularEvent from"@typo3/core/event/regular-event.js";import{ModuleStateStorage}from"@typo3/backend/storage/module-state-storage.js";import{default as Modal}from"@typo3/backend/modal.js";import{SeverityEnum}from"@typo3/backend/enum/severity.js";import Severity from"@typo3/backend/severity.js";import{MultiRecordSelectionSelectors}from"@typo3/backend/multi-record-selection.js";var Selectors;!function(e){e.fileListFormSelector='form[name="fileListForm"]',e.commandSelector='input[name="cmd"]',e.searchFieldSelector='input[name="searchTerm"]',e.pointerFieldSelector='input[name="pointer"]'}(Selectors||(Selectors={}));export const fileListOpenElementBrowser="typo3:filelist:openElementBrowser";export default class Filelist{constructor(){this.downloadFilesAndFolders=e=>{const t=e.target,o=e.detail,r=o.configuration,i=[];o.checkboxes.forEach((e=>{const t=e.closest(MultiRecordSelectionSelectors.elementSelector);t?.dataset[r.folderIdentifier]?i.push(t.dataset[r.folderIdentifier]):t?.dataset[r.fileIdentifier]&&i.push(t.dataset[r.fileIdentifier])})),i.length?this.triggerDownload(i,r.downloadUrl,t):Notification.warning(lll("file_download.invalidSelection"))},this.downloadFolder=e=>{const t=e.target,o=t.dataset.folderIdentifier;this.triggerDownload([o],t.dataset.folderDownload,t)},Filelist.processTriggers(),new RegularEvent(fileListOpenElementBrowser,(e=>{const t=new URL(e.detail.actionUrl,window.location.origin);t.searchParams.set("expandFolder",e.detail.identifier),t.searchParams.set("mode",e.detail.mode);Modal.advanced({type:Modal.types.iframe,content:t.toString(),size:Modal.sizes.large}).addEventListener("typo3-modal-hidden",(()=>{top.list_frame.document.location.reload()}))})).bindTo(document),DocumentService.ready().then((()=>{document.querySelector(".t3-filelist-container");new RegularEvent("click",((e,t)=>{e.preventDefault(),document.dispatchEvent(new CustomEvent(fileListOpenElementBrowser,{detail:{actionUrl:t.href,identifier:t.dataset.identifier,mode:t.dataset.mode}}))})).delegateTo(document,".t3js-element-browser"),new RegularEvent("click",((e,t)=>{e.preventDefault(),Filelist.openInfoPopup(t.dataset.filelistShowItemType,t.dataset.filelistShowItemIdentifier)})).delegateTo(document,"[data-filelist-show-item-identifier][data-filelist-show-item-type]"),new RegularEvent("click",((e,t)=>{e.preventDefault(),Filelist.openInfoPopup("_FILE",t.dataset.identifier)})).delegateTo(document,"a.filelist-file-info"),new RegularEvent("click",((e,t)=>{e.preventDefault(),Filelist.openInfoPopup("_FILE",t.dataset.identifier)})).delegateTo(document,"a.filelist-file-references"),new RegularEvent("click",((e,t)=>{e.preventDefault();const o=t.getAttribute("href");let r=o?encodeURIComponent(o):encodeURIComponent(top.list_frame.document.location.pathname+top.list_frame.document.location.search);top.list_frame.location.href=o+"&redirect="+r})).delegateTo(document,"a.filelist-file-copy"),new RegularEvent("dragstart",((e,t)=>{const o=[],r=document.querySelectorAll(MultiRecordSelectionSelectors.checkboxSelector+":checked");if(r.length>0)for(let e of r){const t=e.closest("[data-filelist-draggable-container]");o.push({type:t.dataset.type,identifier:t.dataset.identifier,name:t.dataset.name,extra:{referencedElement:t.querySelector("img"),stateIdentifier:t.dataset.stateIdentifier}})}else{const e=t.closest("[data-filelist-draggable-container]");o.push({type:e.dataset.type,identifier:e.dataset.identifier,name:e.dataset.name,extra:{referencedElement:e.querySelector("img"),stateIdentifier:e.dataset.stateIdentifier}})}this.drawDataTransferPreview(e.dataTransfer,o),e.dataTransfer.setData("application/json",JSON.stringify(o))})).delegateTo(document,'.t3-filelist-container [draggable="true"]')})),new RegularEvent("multiRecordSelection:action:edit",this.editFileMetadata).bindTo(document),new RegularEvent("multiRecordSelection:action:delete",this.deleteMultiple).bindTo(document),new RegularEvent("multiRecordSelection:action:download",this.downloadFilesAndFolders).bindTo(document),new RegularEvent("click",this.downloadFolder).delegateTo(document,"button[data-folder-download]"),new RegularEvent("multiRecordSelection:action:copyMarked",(e=>{Filelist.submitClipboardFormWithCommand("copyMarked",e.target)})).bindTo(document),new RegularEvent("multiRecordSelection:action:removeMarked",(e=>{Filelist.submitClipboardFormWithCommand("removeMarked",e.target)})).bindTo(document),new RegularEvent("multiRecordSelection:checkbox:state:changed",(e=>{const t=e.target,o=t.closest(MultiRecordSelectionSelectors.elementSelector);if(null!==o&&(o.draggable=t.checked),t.checked){document.querySelectorAll(MultiRecordSelectionSelectors.checkboxSelector+":not(:checked)").forEach((e=>{const t=e.closest("[data-filelist-draggable]");t.draggable=!1,t.querySelectorAll("[data-filelist-draggable]").forEach((e=>{e.draggable=!1}))}))}else{0===document.querySelectorAll(MultiRecordSelectionSelectors.checkboxSelector+":checked").length&&document.querySelectorAll(".t3-filelist-container [data-filelist-draggable]").forEach((e=>{e.draggable=!0,e.querySelectorAll("[data-filelist-draggable]").forEach((e=>{e.draggable=!0}))}))}})).bindTo(document);const e=""!==document.querySelector([Selectors.fileListFormSelector,Selectors.searchFieldSelector].join(" "))?.value;new RegularEvent("search",(t=>{const o=t.target;""===o.value&&e&&o.closest(Selectors.fileListFormSelector)?.submit()})).delegateTo(document,Selectors.searchFieldSelector)}static submitClipboardFormWithCommand(e,t){const o=t.closest(Selectors.fileListFormSelector);if(!o)return;const r=o.querySelector(Selectors.commandSelector);if(r){if(r.value=e,"copyMarked"===e||"removeMarked"===e){const e=o.querySelector(Selectors.pointerFieldSelector),t=Filelist.parseQueryParameters(document.location).pointer;e&&t&&(e.value=t)}o.submit()}}static openInfoPopup(e,t){InfoWindow.showItem(e,t)}static processTriggers(){const e=document.querySelector(".filelist-main");if(null===e)return;const t=encodeURIComponent(e.dataset.filelistCurrentIdentifier);ModuleStateStorage.update("file",t,!0,void 0),Filelist.emitTreeUpdateRequest(e.dataset.filelistCurrentIdentifier)}static emitTreeUpdateRequest(e){const t=new BroadcastMessage("filelist","treeUpdateRequested",{type:"folder",identifier:e});broadcastService.post(t)}static parseQueryParameters(e){let t={};if(e&&Object.prototype.hasOwnProperty.call(e,"search")){let o=e.search.substr(1).split("&");for(let e=0;e<o.length;e++){const r=o[e].split("=");t[decodeURIComponent(r[0])]=decodeURIComponent(r[1])}}return t}static getReturnUrl(e){return""===e&&(e=top.list_frame.document.location.pathname+top.list_frame.document.location.search),encodeURIComponent(e)}drawDataTransferPreview(e,t){if(null===e||0===t.length)return;const o="dragstart-canvas";document.getElementById(o)?.remove();const r=document.createElement("canvas"),i=r.getContext("2d");if(!t.some((e=>!(e.extra.referencedElement instanceof HTMLImageElement)))&&t.length<=5){const e=this.calculateDrawImageCanvasConfiguration(t);r.width=e.width,r.height=e.height;for(let t of e.operations)i.drawImage(t.reference,t.offsetX,t.offsetY)}else{const e=1,o=t.length.toString(10);i.font="16px verdana, arial, sans-serif";const n=i.measureText(o),l=Math.max(Math.ceil(n.width))+32,a=32;r.width=l,r.height=a,i.beginPath(),i.rect(0,0,l,a),i.fillStyle="#f2f8fe",i.fill(),i.lineWidth=e,i.strokeStyle="#3393eb",i.stroke(),i.fillStyle="#313131",i.textAlign="center",i.textBaseline="middle",i.font="16px verdana, arial, sans-serif",i.fillText(o,l/2,a/2)}const n=document.createElement("img");n.id=o,n.src=r.toDataURL("data/png"),document.body.appendChild(n),e.setDragImage(n,0,0)}calculateDrawImageCanvasConfiguration(e){let t=0,o=0,r=0,i=0,n=[];e=e.filter((e=>e.extra.referencedElement instanceof HTMLImageElement));for(let l=0;l<e.length;++l){const a=e[l].extra.referencedElement;l>0&&(r+=Math.max(20,Math.floor(a.width/100*20)),i+=Math.max(20,Math.floor(a.height/100*20))),a.width+r>t&&(t=a.width+r),a.height+i>o&&(o=a.height+i),n.push({offsetX:r,offsetY:i,reference:a})}return{width:t,height:o,operations:n}}deleteMultiple(e){e.preventDefault();const t=e.detail.configuration;Modal.advanced({title:t.title||"Delete",content:t.content||"Are you sure you want to delete those files and folders?",severity:SeverityEnum.warning,buttons:[{text:TYPO3.lang["button.close"]||"Close",active:!0,btnClass:"btn-default",trigger:(e,t)=>t.hideModal()},{text:t.ok||TYPO3.lang["button.ok"]||"OK",btnClass:"btn-"+Severity.getCssClass(SeverityEnum.warning),trigger:(t,o)=>{Filelist.submitClipboardFormWithCommand("delete",e.target),o.hideModal()}}]})}editFileMetadata(e){e.preventDefault();const t=e.detail,o=t.configuration;if(!o||!o.idField||!o.table)return;const r=[];t.checkboxes.forEach((e=>{const t=e.closest(MultiRecordSelectionSelectors.elementSelector);null!==t&&t.dataset[o.idField]&&r.push(t.dataset[o.idField])})),r.length?window.location.href=top.TYPO3.settings.FormEngine.moduleUrl+"&edit["+o.table+"]["+r.join(",")+"]=edit&returnUrl="+Filelist.getReturnUrl(o.returnUrl||""):Notification.warning("The selected elements can not be edited.")}triggerDownload(e,t,o){Notification.info(lll("file_download.prepare"),"",2);const r=o.innerHTML;o.setAttribute("disabled","disabled"),Icons.getIcon("spinner-circle-dark",Icons.sizes.small).then((e=>{o.innerHTML=e})),NProgress.configure({parent:"#typo3-filelist",showSpinner:!1}).start(),new AjaxRequest(t).post({items:e}).then((async e=>{let t=e.response.headers.get("Content-Disposition");if(!t){const t=await e.resolve();return void(!1===t.success&&t.status?Notification.warning(lll("file_download."+t.status),lll("file_download."+t.status+".message"),10):Notification.error(lll("file_download.error")))}t=t.substring(t.indexOf(" filename=")+10);const o=await e.raw().arrayBuffer(),r=new Blob([o],{type:e.raw().headers.get("Content-Type")}),i=URL.createObjectURL(r),n=document.createElement("a");n.href=i,n.download=t,document.body.appendChild(n),n.click(),URL.revokeObjectURL(i),document.body.removeChild(n),Notification.success(lll("file_download.success"),"",2)})).catch((()=>{Notification.error(lll("file_download.error"))})).finally((()=>{NProgress.done(),o.removeAttribute("disabled"),o.innerHTML=r}))}}